import abc
from aiohttp import ClientSession
import abc


class YoLinkAuthMgr(metaclass=abc.ABCMeta):
    """YoLink API Authentication Manager."""

    def __init__(self, webSession: ClientSession) -> None:
        """YoLink Auth Manager"""
        self.webSession = webSession

    def client_session(self):
        """Get client session."""
        return self.webSession

    @abc.abstractmethod
    def access_token(self):
        """Get auth token."""
        pass

    def http_auth_header(self):
        """Get auth header."""
        return f"Bearer {self.access_token()}"

    @abc.abstractmethod
    async def check_and_refresh_token(self) -> str:
        """Check and fresh token."""
        pass
